#!/usr/bin/perl

use LWP::Simple;

$page = get( "http://www.amctv.com/guide/0,,---D--Y-EST,00.html" );

$page =~ s/<\/td><td>/\t/g;
$page =~ s/<[^>]*>//g;
$page =~ s/\&nbsp;/ /g;
$page =~ s/\&amp;/\&/g;
$page =~ s/[\t ]+[\t ]+/\t/g;
$page =~ s/\t+\n//g;
$page =~ s/\n+/\n/g;
$page =~ s/\n\t/\t/g;

@items = split( "\n", $page );

print "Content-type: text/rss+xml\n\n";
print qq~<?xml version="1.0" encoding="iso-8859-1"?>
<rss version="0.91">
	<channel>
		<title>AMC Movie Guide</title>
		<link>http://www.amctv.com/guide</link>
		<description>AMC Guide is where you'll find what's on AMC plus get fact-packed previews of the movies and programs you want to watch!</description>
		<language>en-us</language>
		<webMaster>phytar\@csh.rit.edu</webMaster>
~;

my $itemDone = 0;

foreach $item ( @items ) {
	if ( $item =~ /\t/ ) {
		if ( $item !~ /^\d/ ) {
			if ( $itemDone ) {
				print qq~\t\t\t</table></font>]]></description>\n\t\t</item>\n~;
			}
			$item =~ s/\t/ /g;
			print qq~\t\t<item>
			<title>$item</title>
			<link>http://www.amctv.com/guide</link>
			<description><![CDATA[<font face="Arial"><table>~;
		} else {
			@parts = split( "\t", $item );
			$parts[ 0 ] =~ s/\/EST//;

			if ( $done{ $parts[ 1 ]  } eq "" ) {
				#( $id, $title ) = &getMovie( $parts[ 1 ] );
				$done{ $parts[ 1 ] } = $id . "::" . $title;
			} else {
				( $id, $title ) = split( /::/, $done{ $parts[ 1 ] } );
			}

			$title =~ /\(([^\)]*)\)/;
			$year = $1;

			$time = $parts[ 3 ];
			$time =~ s/ min//g;
			if ( $time < 90 ) {
				$id = "";
			}

			if ( $year eq "" || $id eq "" ) {
			print qq~\t\t\t\t<tr><td nowrap align="right"><font size="2">$parts[0]</font></td>\n\t\t\t\t<td><font size="2">$parts[1]</font></td><td nowrap align="center"><font size="2">$parts[2]</font></td><td nowrap align="right"><font size="2">$parts[3]</font></td></tr>\n~;
			} else {	
			print qq~\t\t\t\t<tr><td nowrap align="right"><font size="2">$parts[0]</font></td>\n\t\t\t\t<td><font size="2"><a href="http://us.imdb.com/Title?$id"><b>$parts[1] ($year)</b></a></font></td><td nowrap align="center"><font size="2">$parts[2]</font></td><td nowrap align="right"><font size="2">$parts[3]</font></td></tr>\n~;
			}
		}
		$itemDone = 1;
	}
}

print qq~\t\t</table></font>]]></description>
\t\t</item>
\t</channel>
</rss>
~;

sub getMovie {
	my $search = $_[0];
	my %retVal = (), $title = "", $id = "";

	$page = get("http://www.imdb.com/Find?select=Titles&for=$search\&Go=Go");

	if ( $page =~ /<H2><A NAME="mov">Movies<\/A><\/H2>(.+)<\/OL>/is) {
		my ( $movie_html, $junk ) = split( /<\/OL>/, $1 );
		my @movie_lines = split( /\n/, $movie_html );

		foreach $line ( @movie_lines ) {
			if ( $line =~ /<a href="\/Title\?([^"]*)">([^<]*?)<\/A>/i && $id eq "" ) {
				$title = $2;
				$id = $1;
			}
		}
	} else {
		$page =~ /<title>([^<]*)<\/title>/i;
		$title = $1;
		$page =~ /<a href="\/Details\?(.*?)">/i;
		$id = $1;
	}

	return ( $id, $title );
}
